<template>
  <a
    :href="contentOnOwnInstanceURL(event.url, userInstance.instanceRedirectURI)"
    target="_blank"
    rel="noopener"
    :class="`flex flex-col items-center bg-white rounded-lg ${
      hasBorder ? 'border dark:border-gray-700 shadow-md' : ''
    } ${
      isRowMode ? 'md:flex-row' : 'md:flex-col'
    } my-4 hover:bg-gray-100 dark:bg-gray-800 dark:hover:bg-gray-700`"
  >
    <img
      v-if="event.banner && !bannerLoadingError"
      :class="`object-cover ${minimal ? 'h-40' : 'h-56'} w-full ${
        isRowMode ? 'md:max-w-[20rem]' : ''
      } ${
        hasBorder && isRowMode
          ? 'rounded-t-lg md:rounded-none md:rounded-l-lg'
          : ''
      }${!isRowMode ? 'rounded-t-lg' : ''}`"
      @error="bannerLoadingError = true"
      :src="event.banner"
      width="350"
      alt=""
    />
    <img
      v-else
      :class="`object-cover ${minimal ? 'h-40' : 'h-56'} w-full ${
        isRowMode ? 'md:max-w-[20rem]' : ''
      } ${
        hasBorder && isRowMode
          ? 'rounded-t-lg md:rounded-none md:rounded-l-lg'
          : ''
      }${!isRowMode ? 'rounded-t-lg' : ''}`"
      src="/img/mobilizon_default_card.png"
      width="350"
      alt=""
    />

    <div
      class="flex self-start flex-col justify-between p-2 md:p-4 leading-normal w-full"
    >
      <span class="text-gray-700 dark:text-white font-semibold">{{
        formatDateTimeWithCurrentLocale
      }}</span>
      <h2
        dir="auto"
        :class="`mb-2 font-bold tracking-tight text-gray-900 dark:text-white ${
          minimal ? 'text-xl line-clamp-2' : 'text-2xl line-clamp-3'
        }`"
      >
        {{ event.name }}
      </h2>

      <div class="pb-3 font-normal text-gray-700 dark:text-gray-400">
        <actor-miniature
          v-if="event.group || event.creator"
          :type="isGroup ? 'group' : 'account'"
          :actor="isGroup ? event.group : event.creator"
          :minimal="minimal"
        />

        <router-link
          v-if="!minimal && event.location?.address?.addressLocality"
          :to="{
            name: 'SEARCH',
            query: {
              ...$route.query,
              lat: event.location.location.lat,
              lon: event.location.location.lon,
              locationName: event.location.address.addressLocality,
              mode: 'list',
            },
          }"
          class="flex gap-1 hover:underline max-w-xs lg:max-w-lg xl:max-w-xl"
          :title="
            $gettext('View more events near %{locality}', {
              locality: event.location.address.addressLocality,
            })
          "
        >
          <svg
            width="24"
            height="24"
            stroke-width="1.5"
            viewBox="0 0 24 24"
            fill="none"
            xmlns="http://www.w3.org/2000/svg"
            class="stroke-red-300 fill-transparent"
          >
            <path
              d="M20 10C20 14.4183 12 22 12 22C12 22 4 14.4183 4 10C4 5.58172 7.58172 2 12 2C16.4183 2 20 5.58172 20 10Z"
              stroke-width="1.5"
            />
            <path
              d="M12 11C12.5523 11 13 10.5523 13 10C13 9.44772 12.5523 9 12 9C11.4477 9 11 9.44772 11 10C11 10.5523 11.4477 11 12 11Z"
              stroke-linecap="round"
              stroke-linejoin="round"
            />
          </svg>

          <span
            v-if="
              event.location.name !== event.location.address.streetAddress &&
              event.location.name !== event.location.address.addressLocality
            "
          >
            {{ event.location.name }},
            {{ event.location.address.addressLocality }},
            {{ event.location.address.addressCountry }}
          </span>
          <span v-else>
            {{ event.location.address.addressLocality }},
            {{ event.location.address.addressCountry }}
          </span>
        </router-link>

        <div
          v-if="event.tags && event.tags.length !== 0 && !minimal"
          class="flex flex-wrap gap-y-2 mt-5"
          dir="auto"
        >
          <router-link
            v-for="tag in event.tags"
            :key="tag"
            :to="{
              name: 'SEARCH',
              query: { ...$route.query, tagsOneOf: tag.substring(1) },
            }"
            class="bg-blue-100 text-blue-800 text-xs font-semibold mr-2 px-2.5 py-0.5 rounded dark:bg-blue-200 dark:text-blue-800"
            >{{ tag }}</router-link
          >
        </div>
        <p v-if="event.participantCount > 0">
          <span
            class="bg-blue-100 text-blue-800 text-xs font-semibold mr-2 px-2.5 py-0.5 rounded dark:bg-blue-200 dark:text-blue-800"
            >{{
              $ngettext(
                'One participant',
                '%{participantCount} participants',
                event.participantCount,
                { participantCount: event.participantCount.toString() }
              )
            }}</span
          >
        </p>
      </div>
    </div>
  </a>
</template>

<script setup lang="ts">
  import { computed, inject, ref } from 'vue'
  import { EnhancedEvent } from '../../../../server/types/event.model'
  import ActorMiniature from '../ActorMiniature.vue'
  import { formatDateTime } from '@/shared/utils'
  import { Locale } from 'date-fns'
  import { contentOnOwnInstanceURL } from '../../plugins/preferredInstance'
  import { UserInstanceData } from '../../../../shared/remote-instance'

  const props = withDefaults(
    defineProps<{
      event: EnhancedEvent
      viewMode?: 'row' | 'column'
      hasBorder?: boolean
      minimal?: boolean
    }>(),
    {
      viewMode: 'row',
      hasBorder: true,
      minimal: false,
    }
  )

  const isRowMode = computed<boolean>(() => props.viewMode == 'row')

  const bannerLoadingError = ref(false)

  const isGroup = computed<boolean>(
    () => props.event.group && props.event.group.url !== props.event.creator.url
  )

  const dateFnsLocale = inject<Locale>('dateFnsLocale')

  const formatDateTimeWithCurrentLocale = computed(() => {
    return formatDateTime(new Date(props.event.startTime), dateFnsLocale)
  })

  const userInstance = inject<UserInstanceData>('userInstance')
</script>
